import sys, re, urllib, urlparse
from ctypes import *

def strip_html(s):
    s = re.sub("<.*?>","",s)
    s = s.replace("&nbsp;"," ")
    return s
def main(start):
    #if not (start.startswith("http://") and start.endswith(".htm")):
    #    print "Need a full Baen URL (e.g. http://www.baen.com/library/0671319728/0671319728.htm)"
    #    sys.exit(1)
    pos = start.rfind("/")
    base = start[:pos+1]   #http://www.baen.com/library/0671319728/
    #isbn = start[pos+1:-4] #0671319728
    #print base, isbn

    f = urllib.urlopen(start)
    main = f.read()
    m2 = re.search(r"isbn = (\"|')(.*)(\"|')", main);
    m = re.search(r"<title>(.*) by (.*) - Baen Books<\/title>", main);
    #print m, m2
    if m and m2:
        title = m.group(1)
        author = m.group(2)
        isbn = m2.group(2)
        at = "%s - %s"%(author, title)
        print "Preparing book: %s"%at
        rsp = file("%s.rsp"%at,"w")
        rsp.write("A:%s\n"%author)
        rsp.write("T:%s\n"%title)
        rsp.write("O:%s.lrf\n"%at)
        f = urllib.urlopen(base+isbn+"_toc.htm")
        m = re.findall(r'<a href="(.*)">(.*)</a>[\r\n\s]*<br\s*/>', f.read())
        i = 0
        m1 = []
        while i<len(m):
            title = m[i][1]
            while i+1<len(m) and m[i][0]==m[i+1][0]:
                title += ". "+m[i+1][1]
                del m[i+1]
            m1.append((m[i][0],strip_html(title)))
            i+=1
        #print m
        rsp.write("P:%s|%s\n"%(base+isbn+"__c_.htm","Cover"))
        for i in m1:
            rsp.write("P:%s|%s\n"%(base+i[0],i[1]))
        rsp.close()
        file("%s.bat"%at,"w").write("html2lrf -r \"%s.rsp\"\n"%at)
    else:
        print "Title or ISBN not found!"
        sys.exit(1)

print "Baen books HTML2LRF helper 0.1 (c) 2006 igorsk"
if len(sys.argv)<2:
    print "Usage: baen.py <start book url>\nE.g. baen.py http://www.baen.com/library/0671319728/0671319728.htm"
else:
    main(sys.argv[1])
